(*******************************************************************************
 *                                                                             *
 *   Graphx : conversion image -> tga                                          *
 *                                                                             *
 *******************************************************************************)

#open "graphx";;
#open "graph";;

let output_tga canal img =

  let sx = vect_length img.(0)
  and sy = vect_length img
  and byte   = output_byte   canal
  and string = output_string canal
  and char   = output_char   canal in
  let short(i) = byte(i land 255); byte(i/256)
  and color(c) = byte(c land 255); byte((c/256) land 255); byte(c/65536) in

  (* prambule *)
  byte 0;			(* ID length      - Field 1 *)
  byte 0;			(* Color Map Type - Field 2 *)
  byte 2;			(* Image Type     - Field 3 *)
  for i=1 to 5 do byte 0 done;	(* Color Map Spec - Field 4 *)
  				(* Image Spec     - Field 5 *)
  short 0;			(* X-origin *)
  short 0;			(* Y-origin *)
  short sx;			(* Width    *)
  short sy;			(* Height   *)
  byte  24;			(* Depth    *)
  byte  0;			(* Descr.   *)

  (* matrice des couleurs *)
  for i=sy-1 downto 0 do do_vect color img.(i) done;

  (* pilogue *)
  for i=1 to 4 do byte 0 done;  (* Ext. Offset - Field 28 *)
  for i=1 to 4 do byte 0 done;  (* Dev. Offset - Field 29 *)
  string "TRUEVISION-XFILE";    (* Signature   - Field 30 *)
  char `.`;                     (* Reserved    - Field 31 *)
  byte  0                       (* Terminator  - Field 32 *)

;;
