(*******************************************************************************
 *                                                                             *
 *   Graphx : conversion image -> ppm                                          *
 *                                                                             *
 *******************************************************************************)

open Graph;;
open Printf;;

let output raw canal img =

  let sx = Array.length img.(0)
  and sy = Array.length img
  and color = if raw then fun c -> output_byte canal (c/65536);
                                   output_byte canal ((c/256) land 255);
                                   output_byte canal (c land 255)
                     else fun c -> fprintf canal " %d %d %d\n"
                                   (c/65536)
                                   ((c/256) land 255)
                                   (c land 255)
  in

  (* prambule *)
  fprintf canal "%s\n%d %d\n255\n" (if raw then "P6" else "P3") sx sy;

  (* matrice des couleurs *)
  Array.iter (Array.iter color) img;

  (* pilogue *)
;;

let output_ppm    = output false
and output_ppmraw = output true
;;
